/**
 * baseado no trabalho  de
 * AVR LC/Frequency Meter
 * Kerry Wong
 * http://www.kerrywong.com
*************************************************
 * adaptado e modificado por py2ohh miguel
 ************************************************
 */

#include <LiquidCrystal.h>
#include <FreqCounter.h>
LiquidCrystal lcd(3, 6, 10, 11, 12, 13);// estes pinos podem ser modificados a gosto
unsigned long frq;
int modo;

int ChvCal = 2; // zero
float F0 = 516015;
float v;
const float Cth = 1515 * 1e-12; // 1500pF+15pF parasita
const float Lth = 63.42 * 1e-6; //61.1+2,32 µH ajustado
float l0 = Lth;
float c0 = Cth;

void setup() {
  lcd.begin(16, 2);
  digitalWrite(7, HIGH);//sensor L/C
  digitalWrite(ChvCal, HIGH);
  verificachave();
}

void loop() {
  FreqCounter::f_comp = 100;//ajuste de leitura de frequencia
  FreqCounter::start(1000);//tempos de leitura 1segundo
  delay(100);
  while (FreqCounter::f_ready == 0)
    frq = FreqCounter::f_freq; //lê a frequencia
  verificachave();
  if (digitalRead(ChvCal) == LOW) {
    switch (modo) {
      case 1:
        c0 = calcV(frq, Cth) + Cth;
        F0 = frq ;
        break;
      case 2:
        l0 = calcV(frq, Lth) + Lth;
        F0 = frq;
        break;
      case 3:
        break;
      default:
        break;
    }
    lcd.setCursor(12, 0);
    lcd.print("Cal");
  }
  displayV(frq);
 // delay(1000);
 // displayFreq(frq); // usado somente para teste
//  delay(1000);// usado somente para teste
}
void verificachave() {
  if (digitalRead(7) == LOW) {
    modo = 2;
    lcd.setCursor(0, 0);
    lcd.print("INDUTOR        ");
  } else {
    modo = 1;
    lcd.setCursor(0, 0);
    lcd.print("CAPACITOR      ");
  }
}
void displayFreq(long fin) {
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  float f = 0;
  if (fin < 1000) {
    f = 1.0 * ((float) fin);
    lcd.print(f, 0);
    lcd.print(" Hz");
  } else if (fin >= 1000) {
    f = ((float) fin) / 1000.0;
    lcd.print(f, 3);
    lcd.print(" KHz");
  }
}

void displayV(float f) {
  //float f = (float) fin;
  float v = 0;
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  switch (modo) {
    case 1:
      v = calcV(f, c0);
      if (v < 1e-9) {
        v = (v * 1e12); // pico
        lcd.print(v);
        lcd.print(" ");
        lcd.print("pF");
      }    else if (v >= 1e-9 && v < 1e-6) {
        v = v * 1e9; // n
        lcd.print(v);
        lcd.print(" ");
        lcd.print("nF");
      }    else if (v >= 1e-6 && v < 1e-4) {
        v = v * 1e6; // n
        lcd.print(v);
        lcd.print(" ");
        lcd.print("uF");
      } else {
        lcd.print("---");
      }
      break;
    case 2:
      v = calcV(f, l0);
      if (v < 1e-6) {
        v = v * 1e9; //nH
        lcd.print(v);
        lcd.print(" ");
        lcd.print("nH");
      } else if (v >= 1e-6 && v < 1e-3) {
        v = v * 1e6; //uH
        lcd.print(v);
        lcd.print(" ");
        lcd.print("uH");
      } else if (v >= 1e-3 && v < 1) {
        v = v * 1e3;
        lcd.print(v);
        lcd.print(" ");
        lcd.print("mH");
      } else if (v >= 1 && v < 100) {
        lcd.print(v);
        lcd.print(" ");
        lcd.print("H");
      } else {
        lcd.print("---");
      }
      break;
    case 3 :
      break;
    default:
      break;
  }
}
float calcV(float f, float VRef) {
  float v = 0;
  v = ((F0 * F0) / (f * f) - 1.0) * VRef;
  return v;
}

